#include <psone/bladeps.h>

void InitSprite(void);

extern u_char gopher[];

GsIMAGE tim;

GsSPRITE gopher_sprite;

u_char primitive_buffer[2][9000];

u_long pad = 0;
u_long exit_flag = 0;

void main (void)
{
  int act;

  PadInit ();

  GsInitGraphQuick (320, 240);

  InitSprite();

  FntColor(0, 60, 20, 60);

  while (exit_flag == 0) {

    act = GsGetActiveBuff ();

    GsSetWorkBase(&primitive_buffer[act][0]);

    GsSortClear (170, 110, 110);

    GsSortSprite (&gopher_sprite);

    FntPrint(0, 4,  4, "L1/R1            - rotate left/right");
    FntPrint(0, 4, 14, "Circle/Cross     - scale up/down");
    FntPrint(0, 4, 24, "Direction arrows - move sprite");
    FntPrint(0, 4, 34, "Press L2 to exit");

    WaitVSync();

    GsSwapDispBuff ();

    GsDrawOT ((u_long *) &primitive_buffer[act][0]);
    
    pad = PadRead();

    if ((pad & PAD_L2) > 0) exit_flag++;

    if ((pad & PAD_LEFT) > 0)
      gopher_sprite.x -= 2;

    if ((pad & PAD_RIGHT) > 0)
      gopher_sprite.x += 2;

    if ((pad & PAD_UP) > 0)
      gopher_sprite.y -= 2;

    if ((pad & PAD_DOWN) > 0)
      gopher_sprite.y += 2;

    if ((pad & PAD_CIRCLE) > 0) {
      gopher_sprite.scalex += 50;
      gopher_sprite.scaley += 50;
      }

    if ((pad & PAD_CROSS) > 0) {
      gopher_sprite.scalex -= 50;
      gopher_sprite.scaley -= 50;
      }

    if ((pad & PAD_L1) > 0)
      gopher_sprite.rotate -= (ONE / 90);

    if ((pad & PAD_R1) > 0)
      gopher_sprite.rotate += (ONE / 90);

  }

  PadStop ();
}

//=======================================================
void InitSprite(void)
{
  // Load TIM from memory to frame buffer
  LoadTim((TIMHEADER *)gopher);

  // Get information about TIM
  GsGetTimInfo((TIMHEADER *)gopher, &tim);

  // Set up 'gopher' sprite
  gopher_sprite.r = gopher_sprite.g = gopher_sprite.b = 128;
  gopher_sprite.x = 110;
  gopher_sprite.y = 120;
  gopher_sprite.w = tim.pw;
  gopher_sprite.h = tim.ph;
  gopher_sprite.u = tim.px;
  gopher_sprite.v = tim.py;
  gopher_sprite.clutid = tim.clutid;
  gopher_sprite.tpage = tim.tpage;
  gopher_sprite.scalex = ONE;
  gopher_sprite.scaley = ONE;
  gopher_sprite.rotate = ONE;
}
